
// Filename: scmod.h

//----------------------------------------------------------------------
//  Copyright (c) 2010 by Doulos.
//
//  Licensed under the Apache License, Version 2.0 (the "License");
//  you may not use this file except in compliance with the License.
//  You may obtain a copy of the License at
//
//  http://www.apache.org/licenses/LICENSE-2.0
//
//  Unless required by applicable law or agreed to in writing, software
//  distributed under the License is distributed on an "AS IS" BASIS,
//  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//  See the License for the specific language governing permissions and
//  limitations under the License.
//----------------------------------------------------------------------

#ifndef SCMOD_H
#define SCMOD_H

#include "systemc"
using namespace sc_core;
using std::cout;
using std::endl;

typedef struct {
  unsigned char cmd;
  int addr;
  int data;
} bus_t;

struct i_f: virtual sc_interface
{
  virtual void execute(bus_t* tx) = 0;
};

class scmod: public sc_module, private i_f
{
public:
  sc_export<i_f> bus_export;

  scmod(sc_module_name n);

  void execute(bus_t* tx);
};

#endif
