
// Filename: scwrap.cpp

//----------------------------------------------------------------------
//  Copyright (c) 2010 by Doulos.
//
//  Licensed under the Apache License, Version 2.0 (the "License");
//  you may not use this file except in compliance with the License.
//  You may obtain a copy of the License at
//
//  http://www.apache.org/licenses/LICENSE-2.0
//
//  Unless required by applicable law or agreed to in writing, software
//  distributed under the License is distributed on an "AS IS" BASIS,
//  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//  See the License for the specific language governing permissions and
//  limitations under the License.
//----------------------------------------------------------------------

#include "scwrap.h"

#ifdef CADENCE
  NCSC_MODULE_EXPORT(scwrap);
#endif

#ifdef MENTOR
  SC_MODULE_EXPORT(scwrap);
#endif

extern "C"
void entry(int id, unsigned char cmd, int addr, int* data)
{
  bus_t tx;
  tx.cmd = cmd;
  tx.addr = addr;
  tx.data = *data;
  scwrap::instance[id]->m_scmod->execute( &tx );
  *data = tx.data;
}

extern "C"
const char* get_path(int id)
{
  return scwrap::instance[id]->name();
}

scwrap::scwrap(sc_module_name n)
: sc_module(n)
{
  m_scmod = new scmod("m_scmod");
  id = ++count;

  instance[id] = this;
  cout << "Called scwrap::scwrap(), id = " << id << ", path = " << name() << endl;
}

std::vector<scwrap*> scwrap::instance(0);  // Synopsys forbids definition of static variable in header file

int scwrap::count = 0;

