
// Filename: scmod.cpp

//----------------------------------------------------------------------
//  Copyright (c) 2010 by Doulos.
//
//  Licensed under the Apache License, Version 2.0 (the "License");
//  you may not use this file except in compliance with the License.
//  You may obtain a copy of the License at
//
//  http://www.apache.org/licenses/LICENSE-2.0
//
//  Unless required by applicable law or agreed to in writing, software
//  distributed under the License is distributed on an "AS IS" BASIS,
//  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//  See the License for the specific language governing permissions and
//  limitations under the License.
//----------------------------------------------------------------------

#include "scmod.h"

#ifdef CADENCE
  NCSC_MODULE_EXPORT(scmod);
#endif

#ifdef MENTOR
  SC_MODULE_EXPORT(scmod);
#endif

scmod::scmod(sc_module_name n)
: sc_module(n)
{
  bus_export.bind( *this );
}

void scmod::execute(bus_t* tx)
{
  static int return_data = 0;
  cout << "Called scmod::execute, name = " << name() << ", cmd = " << int(tx->cmd) << ", addr = " << tx->addr
       << ", data = " << tx->data << endl;
  wait(25, SC_NS);
  if (tx->cmd == 0)
    tx->data = return_data++;
}
