
// Filename: scwrap.h

//----------------------------------------------------------------------
//  Copyright (c) 2010 by Doulos.
//
//  Licensed under the Apache License, Version 2.0 (the "License");
//  you may not use this file except in compliance with the License.
//  You may obtain a copy of the License at
//
//  http://www.apache.org/licenses/LICENSE-2.0
//
//  Unless required by applicable law or agreed to in writing, software
//  distributed under the License is distributed on an "AS IS" BASIS,
//  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//  See the License for the specific language governing permissions and
//  limitations under the License.
//----------------------------------------------------------------------

#ifndef SCWRAP_H
#define SCWRAP_H

#include "svdpi.h"
#include <vector>

#ifdef CADENCE
  #define NCSC_INCLUDE_TASK_CALLS
  #define CDN_OR_MEN
#endif

#ifdef MENTOR
  #define MTI_BIND_SC_MEMBER_FUNCTION
  #include "sc_dpiheader.h"
  #define CDN_OR_MEN
#endif

#include "systemc"
using namespace sc_core;
using std::cout;
using std::endl;

#include "scmod.h"

#ifndef CDN_OR_MEN
extern "C"
void entry(int id, char cmd, int addr, int* data);

extern "C"
const char* get_path(int id);

extern "C"
void tx_done(int id, char cmd, int addr, int data);
#endif

class scwrap: public sc_module
{
public:
  scwrap(sc_module_name n);

  scmod* m_scmod;

  SC_HAS_PROCESS(scwrap);
  void thread1();
  void thread2();
  void thread3();
  void thread4();

  static std::vector<scwrap*> instance;
  static int count;
  int id;

  sc_event dpi_event1;
  sc_event dpi_event2;
  sc_event dpi_event3;
  sc_event dpi_event4;

  bus_t*   send_tx1;
  bus_t*   send_tx2;
  bus_t*   send_tx3;
  bus_t*   send_tx4;
};

#endif
